
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the NETMODCFGDLL_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// NETMODCFGDLL_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef NETMODCFGDLL_EXPORTS
#define NETMODCFGDLL_API __declspec(dllexport)
#else
#define NETMODCFGDLL_API __declspec(dllimport)
#endif

// This class is exported from the NetModCfgDll.dll
class NETMODCFGDLL_API CNetModCfgDll {
public:
	CNetModCfgDll(void);
};

extern NETMODCFGDLL_API int nNetModCfgDll;

NETMODCFGDLL_API int fnNetModCfgDll(void);

#define MAX_DEVICE_CNT		            2000          	  //豸
#define NET_MODULE_DATA_LENGTH		    255		          //ģͨʱ󳤶
#define MODULE_DEFAULT_CONFIG_PORT		50000	          //Ĭϵö˿
#define LOCAL_PORT						60000	          //Ĭϱö˿

//ͨ
#define NET_MODULE_CMD_SET			0X01		          //еģ
#define NET_MODULE_CMD_GET			0X02		          //ȡĳģ
#define NET_MODULE_CMD_RESET		0x03		          //λģ
#define NET_MODULE_CMD_SEARCH		0X04		          //еģ

//Ӧ
#define NET_MODULE_ACK_SET			0X81		          //Ӧ
#define NET_MODULE_ACK_GET			0X82		          //Ӧȡ
#define NET_MODULE_ACK_RESEST		0X83		          //Ӧλ
#define NET_MODULE_ACK_SEARCH		0X84		          //Ӧ

#define CH9121_CFG_FLAG				"CH9121_CFG_FLAG"	  //ʶͨ_new
//ͨŽṹ
typedef struct NET_COMM {
	unsigned char flag[16];		                          //ͨűʶΪù㲥ʽͨŵģһ̶ֵ
	unsigned char cmd;			                          //ͷ
	unsigned char id[6];		                          //ʶʶĳģͨţеģͨţֵ0XFFFFFF,Ŀģmacַ+
	unsigned char cfg_mac[6];	                          //˵MAC
	unsigned char len;			                          //
	unsigned char data[NET_MODULE_DATA_LENGTH];	          //
}net_comm,*pnet_comm;

//ģýṹ
#pragma pack(1)
//ģMAC\IPṹ
typedef struct _Mod_MacIP{
	unsigned char mod_ip[4];
	unsigned char mod_mac[6];
	unsigned char mod_name[21];
	unsigned char mod_ver;
}Mod_MacIP,pMod_MacIP; 

typedef struct _DEVICEHW_CONFIG
{
	UCHAR  bDevType;				    /* 豸,豸ͱ */
	UCHAR  bAuxDevType;					/* 豸 */
	UCHAR  bIndex;					    /* 豸 */
	UCHAR  bDevHardwareVer;				/* 豸Ӳ汾 */	
	UCHAR  bDevSoftwareVer;				/* 豸汾 */	
	UCHAR  szModulename[21];		    /* ģ*/
	UCHAR  bDevMAC[ 6 ];				/* ģMACַ */	
	UCHAR  bDevIP[ 4 ];    				/* ģIPַ*/
	UCHAR  bDevGWIP[ 4 ];    			/* ģIP */
	UCHAR  bDevIPMask[ 4 ];    			/* ģ */
	UCHAR  bDhcpEnable;					/* DHCP ʹܣǷDHCP,1:ã0*/
	USHORT wWebPort;					/* WEBҳַ */
	UCHAR  szUsername[8];				/* ûͬģ*/
	UCHAR  bPassWordEn;					/*ʹ 1ʹ 0 */
	UCHAR  szPassWord[8];				/* */
	UCHAR  bUpdateFlag;					/* ̼־1 0*/
	UCHAR  bComcfgEn;					/*Э̽ģʽʹܣ1ʹ 0:ʹ */
	UCHAR  breserved[8];				/* */
}DeviceHWConfigS,*pDeviceHWConfigS;

typedef struct _DEVICEPORT_CONFIG
{
	UCHAR  bIndex;					 /* ˿ */
	UCHAR  bPortEn;					/* ˿ñ־ 1ú 0 */
	UCHAR  bNetMode;				/* 繤ģʽ: 0: TCP SERVER;1: TCP CLENT; 2: UDP SERVER 3UDP CLIENT; */
	UCHAR  bRandSportFlag;			/* TCP ͻģʽ漴ض˿ںţ1 0: */
	USHORT wNetPort;				/* ͨѶ˿ں */	
	UCHAR  bDesIP[ 4 ];    			/* ĿIPַ */
	USHORT wDesPort;				/* TCP ServerģʽʱⲿӵĶ˿ں */
	ULONG  dBaudRate;				/* ڲ: 300---921600bps */
	UCHAR  bDataSize;				/* λ: 5---8λ */	
	UCHAR  bStopBits;				/* ֹͣλ: 1ʾ1ֹͣλ; 2ʾ2ֹͣλ */	
	UCHAR  bParity;					/* Уλ: 0ʾУ; 1ʾżУ; 2ʾ־λ(MARK,1); 3ʾհλ(SPACE,0);  */		
	UCHAR  bPHYChangeHandle;		/* PHYϿSocket1رSocket 2*/
	ULONG  dRxPktlength;			/* RXݴȣ1024 */
	ULONG  dRxPktTimeout;			/* RXݴתȴʱ,λΪ: 10ms,0ʾرճʱ */
	UCHAR  bReConnectCnt;			/* TCP CLIENTʱTCP SERVERԴ*/	
	UCHAR  bResetCtrl;				/* ڸλ: 0ʾմݻ; 1ʾʱմݻ */	
	UCHAR  bDNSFlag;				/* ñ־1 2*/
	UCHAR  szDomainname[20];		/* */
	UCHAR  bDNSHostIP[4];			/* DNS */
	USHORT wDNSHostPort;			/* DNS ˿*/
	UCHAR  breserved[8];			/* */
}DevicePortConfigS,*pDevicePortConfigS;

typedef struct _NET_DEVICE_CONFIG
{   
	DeviceHWConfigS     HWCfg;			     /*ӲȡϢ*/
	DevicePortConfigS   PortCfg[2];          /*豸豸Ϣ*/
}NetDeviceConfigS,*pNetDeviceConfigS;

/***********************************************************************************/
/* :      NetMod_SEARCH                                                      */
/* :    豸                                                     */
/* :    [in] pcip(PCIP, eg:"192.168.1.1")                              */
/* ֵ:  豸                                             */
/***********************************************************************************/
INT  WINAPI  NetMod_SEARCH(CHAR *pcip,Mod_MacIP *mod_macip);                                   

/***********************************************************************************/
/* :      NetMod_GETCFG                                                      */
/* :    ȡָ豸ò                                               */
/* :    [in] pcip(PCIP, eg:"192.168.1.1")                              */
/*              [in] modmac(ҪõģMAC, eg: 0x84,0xC2,0xE4,0x01,0x02,0x03)    */
/*              [out] save_cmd(淵òĽṹ)                           */
/* ֵ:  ִ״̬ʶ                                                   */
/***********************************************************************************/
BOOL  WINAPI  NetMod_GETCFG(CHAR *pcip,CHAR *modmac,net_comm *save_cmd);               

/***********************************************************************************/
/* :      NetMod_SETCFG                                                      */
/* :    ָ豸ò                                               */
/* :    [in] pcip(PCIP, eg:"192.168.1.1")                              */
/*              [in] pcmac(PCMAC, eg: 0x57,0xAB,0xE3,0x01,0x02,0x03)           */
/*              [in] modmac(ҪõģMAC, eg: 0x84,0xC2,0xE4,0x01,0x02,0x03)    */
/*              [in] set_cmd(ҪõĲṹ)                                   */
/* ֵ:  ִ״̬ʶ                                                   */
/***********************************************************************************/
BOOL  WINAPI  NetMod_SETCFG(CHAR *pcip,CHAR *pcmac,CHAR *modmac,net_comm *set_cmd);    

/***********************************************************************************/
/* :      NetMod_RESET                                                       */
/* :    λָ豸                                                       */
/* :    [in] pcip(PCIP, eg:"192.168.1.1")                              */
/*              [in] modmac(ҪõģMAC, eg: 0x84,0xC2,0xE4,0x01,0x02,0x03)    */
/* ֵ:  ִ״̬ʶ                                                   */
/***********************************************************************************/
BOOL  WINAPI  NetMod_RESET(CHAR *pcip,CHAR *modmac);                                   
